#!/usr/bin/python

from mplcore.api import *
from mpl_web import Search
from cgi import parse_qs
from ssx import SSXRedirect

class CGIGood(Good):
	def __init__(self, qs = None):
		self.qs = qs
		self.good = self.get("id")
		self.name = self.get("name")
		self.misc = self.get("misc")
		self.price = self.get("price")
		self.vendor = self.get("vendor")
		self.action = self.get("action")
		self.discount = self.get("discount")
		try:
			self.discount = (100 - float(self.discount)) / 100
		except:
			self.discount = "NULL" 
		if self.action == None:
			self.action = "init"

	def get(self, what, default = None):
		try:
			return self.qs[what][0]
		except Exception,e:
			return default
def handler(req, xml, conf):
	if (req.args == None):
		cgi = None
	else:
		cgi = parse_qs(req.args, keep_blank_values = True, strict_parsing = True)
	sr = Search(cgi)
	cv = CGIGood(cgi)

	mpl = MPL(conf = conf)

	if cv.action == "init":
		xml.data("<ssx:title>MPL: Редактирование товара</ssx:title>\n")
		xml.push("mpl:goods", "mode='edit'")
		xml.data("\n".join(map (lambda x: x.xml(), mpl.good(id = sr.id))))
		xml.pop("mpl:goods")
		return
	elif cv.action == "add":
		xml.data("<ssx:title>MPL: Добавление товара</ssx:title>\n")
		g = Good()
		g.id = "add"
		g.name = "Название товара"
		g.misc = "Реквизиты"
		xml.push("mpl:goods", "mode='edit'")
		xml.data(g.xml())
		xml.push("mpl:vendors", "mode='select'")
		xml.data("\n".join(map (lambda x: x.xml(), mpl.vendor())))
		xml.pop("mpl:goods")
		return
	elif cv.action == "delete":
		mpl.good_delete(int(cv.good))
		raise SSXRedirect("index.py")
	elif cv.action == "edit":
		cv.price = float(cv.price)
		cv.vendor = int(cv.vendor)
		if cv.good == "add":
			cv.id = 0
			cv.id = mpl.good_add(cv)
		else:
			cv.id = int(cv.good)
			mpl.good_update(cv)
		raise SSXRedirect("index.py?id=%s" % cv.id)

	#xml.data("<mpl:search action='search.py'>фильм</mpl:search>\n")
	xml.data("<ssx:title>MPL: Редактирование товара</ssx:title>\n")

